#include <stdio.h>      /* printf()fprintf()ɬ */
#include <sys/socket.h> /* socket()bind()ɬ */
#include <arpa/inet.h>  /* sockaddr_inɬ */
#include <stdlib.h>     /* atoi()ɬ */
#include <string.h>     /* memset()ɬ */
#include <unistd.h>     /* close()ɬ */

void DieWithError(char *errorMessage); /* 顼ؿ */

int main(int argc, char *argv[])
 {
     int sock;                         /* å */
     struct sockaddr_in broadcastAddr; /* ֥ɥ㥹ȥɥ쥹 */
     char *broadcastIP;                /* IP֥ɥ㥹ȥɥ쥹 */
     unsigned short broadcastPort;     /* ФΥݡ */
     char *sendString;                 /* ֥ɥ㥹Ȥʸ */
     int broadcastPermission;          /* ֥ɥ㥹Ȥͭˤ륽åȥץ */
     unsigned int sendStringLen;       /* ֥ɥ㥹ȤʸĹ */

     if (argc < 4)                     /* ѥ᡼οǧ */
     {
         fprintf(stderr,"Usage: %s <IP Address> <Port> <Send String>\n", argv[0]);
         exit(1);
     }

     broadcastIP = argv[1];           /* 1ܤΰ֥ɥ㥹ȤIPɥ쥹 */
     broadcastPort = atoi(argv[2]);   /* 2ܤΰ֥ɥ㥹ѥݡ */
     sendString = argv[3] ;           /* 3ܤΰ֥ɥ㥹Ȥʸ */

     /* ǡ륽åȤ */
     if ((sock = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0)
         DieWithError("socket() failed");

     /* åȤ֥ɥ㥹Ȳǽ */
     broadcastPermission = 1;
     if (setsockopt(sock, SOL_SOCKET, SO_BROADCAST, (void *) &broadcastPermission,
           sizeof(broadcastPermission)) < 0)
         DieWithError("setsockopt() failed");

     /* Υɥ쥹¤Τ */
     memset(&broadcastAddr, 0, sizeof(broadcastAddr));    /* ¤Τ򥼥 */
     broadcastAddr.sin_family = AF_INET;                  /* 󥿡ͥåȥɥ쥹եߥ */
     broadcastAddr.sin_addr.s_addr = inet_addr(broadcastIP);/* ֥ɥ㥹IPɥ쥹 */
     broadcastAddr.sin_port = htons(broadcastPort);          /* ֥ɥ㥹ȥݡ */

     sendStringLen = strlen(sendString);  /* sendStringĹĴ٤ */
     for (;;) /* ץबλޤǷ֤¹ */
     {
         /* sendStringΥǡ򥯥饤Ȥ3äȤ˥֥ɥ㥹Ȥ*/
         if (sendto(sock, sendString, sendStringLen, 0, (struct sockaddr *)
               &broadcastAddr, sizeof(broadcastAddr)) != sendStringLen)
             DieWithError("sendto() sent a different number of bytes than expected");

         sleep(3);  /* ͥåȥäѤˤʤΤɤ */
      }
      /* ʬˤãʤ */
 }
