#include <stdio.h>      /* fprintf()ɬ */
#include <sys/socket.h> /* socket()connect()send()recv()ɬ */
#include <arpa/inet.h>  /* sockaddr_ininet_addr()ɬ */
#include <stdlib.h>     /* atoi()ɬ */
#include <string.h>     /* memset()ɬ */
#include <unistd.h>     /* sleep()ɬ */

void DieWithError(char *errorMessage);  /* 顼ؿ */


int main(int argc, char *argv[])
 {
     int sock;                        /* å */
     struct sockaddr_in multicastAddr; /* ޥ㥹ȥɥ쥹 */
     char *multicastIP;               /* IPޥ㥹ȥɥ쥹 */
     unsigned short multicastPort;     /* ФΥݡ */
     char *sendString;                /* ޥ㥹Ȥʸ */
     unsigned char multicastTTL;      /* ޥ㥹ȥѥåȤTTL */
     unsigned int sendStringLen;      /* ޥ㥹ȤʸĹ */

     if ((argc < 4) || (argc > 5))         /* ѥ᡼οǧ */
     {
         fprintf(stderr, "Usage: %s <Multicast Address> <Port> <Send String> [<TTL>]\n",
                  argv[0]);
         exit(1);
     }

     multicastIP = argv[1];              /* 1ܤΰޥ㥹ȤIPɥ쥹 */
     multicastPort = atoi(argv[2]);      /* 2ܤΰޥ㥹ѥݡ */
     sendString = argv[3];             /* 2ܤΰޥ㥹Ȥʸ */

     if (argc == 5)                    /* TTLޥɥ饤󤫤ꤵƤ뤫 */
         multicastTTL = atoi(argv[4]); /* ޥɥ饤󤫤ꤵ줿TTL */
     else
     multicastTTL = 1;                 /* ǥեȤTTL = 1 */

     /* ǡѥåȤκ */
     if ((sock = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0)
     DieWithError("socket() failed");

     /* ޥ㥹ȥѥåȤTTL */
     if (setsockopt(sock, IPPROTO_IP, IP_MULTICAST_TTL, (void *) &multicastTTL,
           sizeof(multicastTTL)) < 0)
         DieWithError("setsockopt() failed");

     /* Υɥ쥹¤Τ */
     memset(&multicastAddr, 0, sizeof(multicastAddr)); /* ¤Τ򥼥 */
     multicastAddr.sin_family = AF_INET;               /* 󥿡ͥåȥɥ쥹եߥ */
     multicastAddr.sin_addr.s_addr = inet_addr(multicastIP);/* ޥ㥹IPɥ쥹 */
     multicastAddr.sin_port = htons(multicastPort);       /* ޥ㥹Ȥݡ */

     sendStringLen = strlen(sendString); /* sendStringĹĴ٤ */
     for (;;) /* ץबλޤǷ֤¹ */
     {
         /* sendStringΥǡ3äȤ˥饤Ȥإޥ㥹Ȥ */
         if (sendto(sock, sendString, sendStringLen, 0, (struct sockaddr *)
               &multicastAddr, sizeof(multicastAddr)) != sendStringLen)
             DieWithError("sendto() sent a different number of bytes than expected");
         sleep(3);
     }
     /* ʬˤãʤ */
 }

