#include <stdio.h>	/* printf()fprintf()ɬ */
#include <sys/socket.h>	/* socket()connect()send()recv()ɬ */
#include <arpa/inet.h>	/* sockaddr_ininet_addr()ɬ */
#include <stdlib.h>	/* atoi()ɬ */
#include <string.h>	/* memset()ɬ */
#include <unistd.h>	/* close()ɬ */

#define RCVBUFSIZE 32	/* ХåեΥ */

void DieWithError(char *errorMessage);	/* 顼ؿ */

int main(int argc, char *argv[])
{
	int sock;			/* åȥǥץ */
	struct sockaddr_in echoServAddr;/* ФΥɥ쥹 */
	unsigned short echoServPort;	/* ФΥݡֹ */
	char *servIP;			/* ФIPɥ쥹dotted-quad */
	char *echoString;	        /* Фʸ */
	char echoBuffer[RCVBUFSIZE];	/* ʸѤΥХåե */
	unsigned int echoStringLen;	/* ʸΥ */
	int bytesRcvd, totalBytesRcvd;	/* recv()ɤ߼
					   ХȿХȿ */

	if ((argc < 3) || (argc > 4))	/* οǧ */
	{
		fprintf(stderr, "Usage: %s <Server IP> <Echo Word> [<Echo Port>}\n",
				argv[0]);
		exit(1);
	}

	servIP = argv[1];		/* 1ܤΰФIPɥ쥹ʥɥå10ɽ */
	echoString = argv[2];	/* 2ܤΰʸ */

	if (argc == 4)
		echoServPort = atoi(argv[3]);	/* Υݡֹ椬л */
	else
		echoServPort = 7;	/* 7ϥӥwell-knownݡֹ */

	/* TCPˤ뿮ι⤤ȥ꡼ॽåȤ */
	if ((sock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0)
		DieWithError("socket() failed");

	/* ФΥɥ쥹¤Τ */
	memset(&echoServAddr, 0, sizeof(echoServAddr));		/* ¤Τ˥ */
	echoServAddr.sin_family = AF_INET;			/* 󥿡ͥåȥɥ쥹եߥ */
	echoServAddr.sin_addr.s_addr = inet_addr(servIP);	/* ФIPɥ쥹 */
	echoServAddr.sin_port = htons(echoServPort);		/* ФΥݡֹ */

	/* Фؤ³Ω */
	if (connect(sock, (struct sockaddr *) &echoServAddr, sizeof(echoServAddr)) < 0)
		DieWithError("connect() failed");

	echoStringLen = strlen(echoString);	/* ϥǡĹĴ٤ */

	/* ʸ򥵡Ф */
	if (send(sock, echoString, echoStringLen, 0) != echoStringLen)
		DieWithError("send() sent a different number of bytes than expected");

	/* Ʊʸ򥵡Ф */
	totalBytesRcvd = 0;
	printf("Received: ");	/* 줿ʸɽ뤿ν */
	while (totalBytesRcvd < echoStringLen)
	{
		/* Хåեãޤǡʥ̥ʸѤ1ХȤ
			ФΥǡ */
		if ((bytesRcvd = recv(sock, echoBuffer, RCVBUFSIZE - 1, 0)) <= 0)
			DieWithError("recv() failed or connection closed prematurely");
		totalBytesRcvd += bytesRcvd;	/* Хȿν */
		echoBuffer[bytesRcvd] = '\0' ;	/* ʸνλ */
		printf(echoBuffer);	/* Хåեɽ */
	}

	printf("\n");	/* ǸβԤ */

	close(sock);
	exit(0);
}

