#include "TCPEchoServer.h"  /* TCPФΥ󥯥롼ɥե */
#include <sys/time.h>        /* timeval{}ɬ */
#include <fcntl.h>          /* fcntl()ɬ */

int main(int argc, char *argv[])
{
     int *servSock;                   /* ФΥåȥǥץ */
     int maxDescriptor;               /* åȥǥץκ */
     fd_set sockSet;                  /* select()оݤȤʤ륽åȥǥץΥå */
     long timeout;                    /* ޥɥ饤󤫤ꤵ줿ॢȤ */
     struct timeval selTimeout;       /* select()Υॢ */
     int running = 1;                 /* ФưǤ1Ǥʤ0 */
     int noPorts;                     /* ޥɥ饤󤫤ꤷݡȤο */
     int port;                        /* ݡȤ롼פѿ */
     unsigned short portNo;           /* ºݤΥݡֹ */

     if (argc < 3)      /* οĴ٤ */
     {
         fprintf (stderr, "Usage:  %s <Timeout (secs.)> <Port 1> ... \n", argv[0]);
         exit(1);
     }

     timeout = atol(argv[1]);        /* 1ܤΰॢȡá */
     noPorts = argc - 2;             /* ݡȤοϡΥȡڴ argcͤǤۤ2 */

     /* 忮³׵륽åȥꥹȤγ */
     servSock = (int *) malloc(noPorts * sizeof(int));

     /* select()ǻѤmaxDescriptorν */
     maxDescriptor = -1;

     /* ݡȡӥݡȤ륽åȤΥꥹȤ */
     for (port = 0; port < noPorts; port++)
     {
         /* ݡȤꥹȤɲ */
         portNo = atoi(argv[port + 2]); /*ǽ2Ĥΰ򥹥å */

         /* ݡȤΥåȤ */
         servSock[port] = CreateTCPServerSocket(portNo);

         /* ǥץͤ礫Ĵ٤ */
         if (servSock[port] > maxDescriptor)
            maxDescriptor = servSock[port];
     }

     printf("Starting server: Hit return to shutdown\n");
     while (running)
     {
         /* åȥǥץΥ٥򥼥ƥФΥåȤ򥻥åȤ */
         /* select()¹Ԥ뤿Ӥ˥ꥻåȤɬ */
         FD_ZERO(&sockSet);
         /* ǥץΥ٥˥ܡɤɲ */
         FD_SET(STDIN_FILENO, &sockSet);
         for (port = 0; port < noPorts; port++)
             FD_SET(servSock[port], &sockSet);

         /* ॢȤλ */
         /* select()¹Ԥ뤿Ӥ˥ꥻåȤɬ */
         selTimeout.tv_sec = timeout;       /* ॢȡá */
         selTimeout.tv_usec = 0;            /* 0ޥ*/

         /* ǥץѲǽޤϥॢȤˤʤޤǥץ */
         if (select(maxDescriptor + 1, &sockSet, NULL, NULL, &selTimeout) == 0)
             printf("No echo requests for %ld secs... Server still alive\n", timeout);
         else
         {
             if (FD_ISSET(STDIN_FILENO, &sockSet)) /* ܡɤΥå */
             {
                 printf("Shutting down server\n");
                 getchar();
                 running = 0;
             }

         for (port = 0; port < noPorts; port++)
             if (FD_ISSET(servSock[port], &sockSet))
             {
                 printf("Request on port %d: ", port);
                 HandleTCPClient(AcceptTCPConnection(servSock[port]));
             }
       }
     }

     /* åȤΥ */
     for (port = 0; port < noPorts; port++)
         close(servSock[port]);

     /* åȤΥꥹȤ꤫ */
     free(servSock);

     exit(0);
 }

