#include <stdio.h>      /* printf()fprintf()ɬ */
#include <sys/socket.h> /* socket()connect()sendto()recvfrom()ɬ */
#include <arpa/inet.h>  /* sockaddr_ininet_addr()ɬ */
#include <stdlib.h>     /* atoi()ɬ */
#include <string.h>     /* memset()ɬ */
#include <unistd.h>     /* close()ɬ */
#include <errno.h>      /* errnoEINTRɬ */
#include <signal.h>     /* sigaction()ɬ */

#define ECHOMAX        255    /* ʸκĹ */
#define TIMEOUT_SECS   2      /* ޤǤÿ */
#define MAXTRIES       5      /* Բ */

int tries=0;   /* Υ󥿡ʥʥϥɥ餫ΥѡХ */

void DieWithfrror(char *errorMessage);   /* 顼ؿ */
void CatchAlarm(int ignored);            /* SIGALRMΥϥɥ */

int main(int argc, char *argv[])
{
    int sock;                       /* åȥǥץ */
    struct sockaddr_in echoServAddr; /* ФΥɥ쥹 */
    struct sockaddr_in fromAddr;     /* Υɥ쥹 */
    unsigned short echoServPort;    /* ФΥݡֹ */
    unsigned int fromSize;        /* recvfrom()Υɥ쥹ϥ */
    struct sigaction myAction;      /* ʥϥɥ */
    char *servIP;                   /* ФIPɥ쥹 */
    char *echoString;               /* Фʸ */
    char echoBuffer[ECHOMAX+1];     /* ʸμХåե */
    int echoStringLen;              /* ʸĹ */
    int respStringLen;              /* ǡĹ */
   
    if ((argc < 3) || (argc > 4))   /* οǧ */
    {
        fprintf(stderr,"Usage: %s <Server IP> <Echo Word> [<Echo Port>]\n", argv[0]);
        exit(1);
    }
   
    servIP = argv[1];           /* 1ܤΰ ФIPɥ쥹ʥɥåȶڤ10ɽ */
    echoString = argv[2];       /* 2ܤΰ ʸ */
   
    if ((echoStringLen = strlen(echoString)) > ECHOMAX)

    DieWithError("Echo word too long");
   
    if (argc == 4)
        echoServPort = atoi(argv[3]); /* Υݡֹ椬л */
    else
        echoServPort = 7; /* ӥwell-knownֹ */
   
    /* ٥ȥեȷUDPǡॽåȤ */
    if ((sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0)
        DieWithError("socket() failed");
   
    /* 顼ॷʥѥʥϥɥΥå */
    myAction.sa_handler = CatchAlarm;
    if (sigfillset(&myAction.sa_mask) < 0) /* ϥɥǤϤ٤Ƥ֥å */
    DieWithError("sigfillset() failed");
    myAction.sa_flags = 0;
   
    if (sigaction(SIGALRM, &myAction, 0) < 0)
        DieWithError("sigaction() failed for SIGALRM");
   
    /* ФΥɥ쥹¤Τ */
    memset(&echoServAddr, 0, sizeof(echoServAddr));  /* ¤Τ򥼥 */

    echoServAddr.sin_family = AF_INET;
    echoServAddr.sin_addr.s_addr = inet_addr(servIP); /* ФIPɥ쥹 */
    echoServAddr.sin_port = htons(echoServPort);       /* ФΥݡֹ */
   
    /* ʸ򥵡Ф */
    if (sendto(sock, echoString, echoStringLen, 0, (struct sockaddr *)
               &echoServAddr, sizeof(echoServAddr)) != echoStringLen)
        DieWithError("sendto() sent a different number of bytes than expected");
   
    /*  */
   
    fromSize = sizeof(fromAddr);
    alarm(TIMEOUT_SECS);        /* ॢȻ֤ */
    while ((respStringLen = recvfrom(sock, echoBuffer, ECHOMAX, 0,
           (struct sockaddr *) &fromAddr, &fromSize)) < 0)
        if (errno == EINTR)     /* 顼νλ */
        {
            if (tries < MAXTRIES) /* triesϥʥϥɥǥ󥯥 */
            {
                printf("timed out, %d more tries...\n", MAXTRIES-tries);
                if (sendto(sock, echoString, echoStringLen, 0, (struct sockaddr *)
                            &echoServAddr, sizeof(echoServAddr)) != echoStringLen)
                    DieWithError("sendto() failed");
                alarm(TIMEOUT_SECS);
             }
             else
                 DieWithError("No Response");
         }
         else
             DieWithError("recvfrom() failed");
   
    /* recvfrom()顢ॢȤ򥭥󥻥 */
    alarm(0);
   
    /* ǡNULLʸǽü */
    echoBuffer[respStringLen] = '\0';
    printf("Received: %s\n", echoBuffer);  /* ǡɽ */
    
     close(sock);
     exit(0);
}

void CatchAlarm(int ignored)    /* SIGALRMΥϥɥ */
{
    tries += 1;
}
