#include <stdio.h> /* printf()fprintf()ɬ */
#include <sys/socket.h> /* socket()connect()sendto()recvfrom()ɬ */
#include <arpa/inet.h> /* sockaddr_ininet_addr()ɬ */
#include <stdlib.h> /* atoi()ɬ */
#include <string.h> /* memset()ɬ */
#include <unistd.h> /* for close()ɬ */

#define ECHOMAX 255 /* ʸκĹ */

void DieWithError(char *errorMessage); /* 顼ؿ */

int main(int argc, char *argv[])
{
  int sock; /* åȥǥץ */
  struct sockaddr_in echoServAddr; /* ФΥɥ쥹 */
  struct sockaddr_in fromAddr; /* Υɥ쥹 */
  unsigned short echoServPort; /* ФΥݡֹ */
  unsigned int fromSize; /* recvfrom()Υɥ쥹ϥ */
  char *servIP; /* ФIPɥ쥹 */
  char *echoString; /* Фʸ */
  char echoBuffer[ECHOMAX+1]; /* ʸμѥХåե */
  int echoStringLen; /* ʸĹ */
  int respStringLen; /* Ĺ */

  if ((argc < 3) || (argc > 4)) /* οǧ */
  {
    fprintf(stderr,"Usage: %s <Server IP> <Echo Word> [<Echo Fort>]\n", argv[0]);
    exit(1);
  }

  servIP = argv[1]; /* 1ܤΰФIPɥ쥹dotted quad*/
  echoString = argv[2]; /* 2ܤΰʸ */

  if ((echoStringLen = strlen(echoString)) > ECHOMAX) /* ϤʸĹå */
    DieWithError("Echo word too long");

  if (argc == 4)
    echoServPort = atoi(argv[3]); /* Υݡֹ椬л */
  else
    echoServPort = 7; /* 7ϥӥwell-knownݡֹ */

  /* UDPǡॽåȤκ */
  if ((sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0)
    DieWithError("socket() failed");

  /* ФΥɥ쥹¤Τκ */
  memset(&echoServAddr, 0, sizeof(echoServAddr)); /* ¤Τ˥ */
  echoServAddr.sin_family = AF_INET; /* 󥿡ͥåȥɥ쥹եߥ */
  echoServAddr.sin_addr.s_addr = inet_addr(servIP); /* ФIPɥ쥹 */
  echoServAddr.sin_port = htons(echoServPort); /* ФΥݡֹ */

  /* ʸ򥵡Ф */
  if (sendto(sock, echoString, echoStringLen, 0, (struct sockaddr *)
         &echoServAddr, sizeof(echoServAddr)) != echoStringLen)
    DieWithError("sendto() sent a different   number of bytes than expected");

  /*  */
  fromSize = sizeof(fromAddr);
  if ((respStringLen = recvfrom(sock, echoBuffer, ECHOMAX, 0,
    (struct sockaddr *) &fromAddr, &fromSize)) != echoStringLen)
    DieWithError("recvfrom() failed");

  if (echoServAddr.sin_addr.s_addr != fromAddr.sin_addr.s_addr)
  {
    fprintf(stderr,"Error: received a packet from unknown source.\n");
    exit(1);
  }

  /* ǡNULLʸǽü */
  echoBuffer[respStringLen] = '\0';
  printf("Received: %s\n", echoBuffer); /* Υʸɽ */

  close(sock);
  exit(0);
}
