#include <stdio.h>     /* printf()fprintf()ɬ */
#include <sys/socket.h> /* socket()bind()connect()ɬ */
#include <arpa/inet.h>  /* sockaddr_ininet_ntoa()ɬ */
#include <stdlib.h>    /* atoi()ɬ */
#include <string.h>    /* memset()ɬ */
#include <unistd.h>    /* close()ɬ */
#include <fcntl.h>     /* fcntl()ɬ */
#include <sys/file.h>  /* O_NONBLOCKFASYNCɬ */
#include <signal.h>     /* signal()SIGALRIAɬ */
#include <errno.h>     /* errnoɬ */

#define ECHOMAX 255    /* ʸκĹ */

void DieWithError(char *errorMessage); /* 顼ؿ */
void UseIdleTime();                    /* ɥ֤Ѥؿ */
void SIGIOHandler(int signalType);     /* SIGIOΥϥɥؿ */

int sock;                        /* åȡʥʥϥɥѤ˥Х˺ */

int main(int argc, char *argv[])
{
    struct sockaddr_in echoServAddr;  /* ФΥɥ쥹 */
    unsigned short echoServPort;      /* ФΥݡֹ */
    struct sigaction handler;         /* ʥΥ */

   /* ѥ᡼οǧ */
   if (argc != 2)
   {
       fprintf(stderr,"Usage: %s <SERVER PORT>\n", argv[0]);
       exit(1);
   }

   echoServPort = atoi(argv[1]); /* 1ܤΰ ݡֹ */

   /* ǡ˻ȤåȤ */
   if ((sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0)
      DieWithError("socket() failed");

   /* ФΥɥ쥹¤Τ򥻥åȥå */
   memset(&echoServAddr, 0, sizeof(echoServAddr));    /* ¤Τ˥ */
   echoServAddr.sin_family = AF_INET;                 /* 󥿡ͥåȥեߥ */
   echoServAddr.sin_addr.s_addr = htonl(INADDR_ANY); /* Ǥդμ󥿥ե */
   echoServAddr.sin_port = htons(echoServPort); /* ݡ */

   /* 륢ɥ쥹إХ */
   if (bind(sock, (struct sockaddr *) &echoServAddr, sizeof(echoServAddr)) < 0)
       DieWithError("bind() failed");

   /* SIGIOΥʥϥɥ */
   handler.sa_handler = SIGIOHandler;
   /* ʥޥޥ */
   if (sigfillset(&handler.sa_mask) < 0)
     DieWithError("sigfillset() failed");
   /* ե饰ʤ */
   handler.sa_flags = 0;

   if (sigaction(SIGIO, &handler, 0) < 0)
       DieWithError("sigaction() failed for SIGIO");

   /* åȤͭSIGIOå */
   if (fcntl(sock, F_SETOWN, getpid()) < 0)
     DieWithError("Unable to set process owner to us");

   /* Υ֥åI/OSIGIO򥻥åȥå */
   if (fcntl(sock, F_SETFL, O_NONBLOCK | FASYNC) < 0)
       DieWithError("Unable to put client sock into nonblocking/async mode");

   /* ΥƤۤλŻ򤹤ʥϥХå饦ɤȯ */

   for (;;)
       UseIdleTime();

   /* ʬˤãʤ */
}

void UseIdleTime()
{
    printf(".\n");
    sleep(3);     /* 3ôư */
}

void SIGIOHandler(int signalType)
{
    struct sockaddr_in echoClntAddr; /* ǡɥ쥹 */
    unsigned int clntLen;            /* ɥ쥹Ĺ */
    int recvMsgSize;                /* ǡΥ */
    char echoBuffer[ECHOMAX];       /* ǡΥХåե */

    do /* ϥǡʤʤޤǼ¹ */
    {
       /* ϥѥ᡼Υ */
       clntLen = sizeof(echoClntAddr);

       if ((recvMsgSize = recvfrom(sock, echoBuffer, ECHOMAX, 0,
              (struct sockaddr *) &echoClntAddr, &clntLen)) < 0)
       {
           /* recvfrom()֥å褦ȤʵƤͣΥ顼 */
           if (errno != EWOULDBLOCK)
               DieWithError("recvfrom() failed");
       }
       else
       {
           printf("Handling client %s\n", inet_ntoa(echoClntAddr.sin_addr));

           if (sendto(sock, echoBuffer, recvMsgSize, 0, (struct sockaddr *)
                 &echoClntAddr, sizeof(echoClntAddr)) != recvMsgSize)
               DieWithError("sendto() failed");
        }
     } while (recvMsgSize >= 0);
     /* ٤Ƥμλ */
 }
